require 'rubygems'
require 'activerecord'
require 'spider'


ActiveRecord::Base.establish_connection(
  :adapter  => "mysql",
  :host => "127.0.0.1",
  :database => "sparkmarble",
  :username => "rubyuser",
  :password => "rubyuser"
)

class Book < ActiveRecord::Base
  set_table_name "books"
  has_many :books_links, :foreign_key => "book_id"
end

class BooksLink < ActiveRecord::Base
  set_table_name "books_links"
  belongs_to :book, :foreign_key => "book_id"
  belongs_to :link, :foreign_key => "link_id"
end

class Link < ActiveRecord::Base
  set_table_name "links"
  has_many :books_links, :foreign_key => "link_id"
end

regex = Regexp.new(/<title>.*<\/title>/)
body_regex = Regexp.new(/<td width="60%" class="body">.*/)

Spider.start_at('http://www.atozteacherstuff.com/Lesson_Plans/') do |s|
	s.add_url_check do |a_url|
		a_url =~ %r{^http://(www.)?atozteacherstuff.com.*}
	end
	
	s.on :success do |a_url, resp, prior_url|
		sleep_time = rand(10)
		raw_title = regex.match(resp.body)
		
		if raw_title
			title = raw_title[0][7,raw_title[0].length - 15]
		else
			title = "No Title"
		end
		
		body = resp.body[0, 4999]
		
		puts "#{a_url} Given this code: #{resp.code} - sleeping #{sleep_time}"
		puts "Title: #{title}"
		
		Link.create :name => title, :url => a_url, :body => resp.body
		sleep(sleep_time)
	end
	
	s.on 404 do |a_url, resp, prior_url|
		puts "Error at #{a_url}"
	end
end