require 'rubygems'
require 'activerecord'
require 'mysql'

=begin
SELECT * FROM information_schema.KEY_COLUMN_USAGE
WHERE REFERENCED_TABLE_SCHEMA = 'sparkmarble_dev'
and table_name = 'attempts'
AND REFERENCED_TABLE_NAME is not null
ORDER BY TABLE_NAME, COLUMN_NAME;
=end

mysql = Mysql.init()
mysql.connect("127.0.0.1", "rubyuser", "rubyuser", "sparkmarble_dev")
r = mysql.query("show tables")

r.each do |row|
	thisRow = row[0]
	puts thisRow.classify
	if (File.exists?("app/models/#{thisRow}.rb"))
		File.delete("app/models/#{thisRow}.rb")
	end
	
	foreign_keys = mysql.query("SELECT table_name, column_name
		FROM information_schema.KEY_COLUMN_USAGE
		WHERE REFERENCED_TABLE_SCHEMA = 'sparkmarble_dev'
		and referenced_table_name = '#{thisRow}'
		AND REFERENCED_TABLE_NAME is not null
		ORDER BY TABLE_NAME, COLUMN_NAME")

	belongs_to = mysql.query("SELECT distinct referenced_table_name, column_name
		FROM information_schema.KEY_COLUMN_USAGE
		WHERE REFERENCED_TABLE_SCHEMA = 'sparkmarble_dev'
		and table_name = '#{thisRow}'
		AND REFERENCED_TABLE_NAME is not null
		ORDER BY TABLE_NAME, COLUMN_NAME")
	
	thisFile = File.new("app/models/#{thisRow.singularize}.rb", "w")
	#puts `script/generate model #{thisRow.singularize}
	thisFile.puts "class #{thisRow.classify} < ActiveRecord::Base"
	
	thisFile.puts "\tset_table_name \"#{thisRow}\""
	
	
	if thisRow.classify == "Book"
		thisFile.puts "\thas_permalink :book_name, :if => Proc.new { |book| book.needs_permalink? }"
	end
	
	
	similar_counter = 0
	last_term = ""
	
	foreign_keys.each do |key|
		if (last_term == key[0])
			similar_counter = similar_counter + 1
			new_term = last_term + "_" + key[1]
			thisFile.puts "  has_many :#{new_term}, :foreign_key => \"#{key[1]}\""
		else
			similar_counter = 0
			thisFile.puts "  has_many :#{key[0]}, :foreign_key => \"#{key[1]}\""
		end
		last_term = key[0]
	end
	
	belongs_to.each do |b_key|
		thisFile.puts "  belongs_to :#{b_key[0].singularize}, :foreign_key => \"#{b_key[1]}\""
	end
	

	if thisRow.classify == "Book"
		contents = File.open("db_book.txt", "r")
		contents.each do |line|
			thisFile.puts line
		end
	end
	
	if thisRow.classify == "Unlockable"
		contents = File.open("db_unlockable.txt", "r")
		contents.each do |line|
			thisFile.puts line
		end
	end
	
	if thisRow.classify == "Quiz"
		thisFile.puts "\thas_many :questions, :through => :quizzes_questions"
	end
	
	if thisRow.classify == "Post"
		thisFile.puts "\tacts_as_ferret :fields => [:name, :description]"
	end
	
	if thisRow.classify == "Group"
		thisFile.puts "\thas_many :quizzes, :through => :groups_quizzes"
		thisFile.puts "\thas_many :books, :class_name => 'Book', :finder_sql => 'select distinct b.* from books b inner join quizzes q on b.id = q.book_id inner join groups_quizzes gq on q.id = gq.quiz_id where gq.group_id = \#{id}'"
	end
	
	thisFile.puts "end"
end
