﻿package
{
	import flash.display.*;
	import flash.events.*;
	import flash.net.*;
		
	import util.*;
	import request.*;
	
	////////////////////////////////////////////////////////////////////////
	//
	////////////////////////////////////////////////////////////////////////
	public class App
	{
		var client:Client;
		var str_url:String;
		var app_scale_x:Number;
		var app_scale_y:Number;
		var app_offset_x:int;
		var app_offset_y:int;
		var app_bg_color:uint;

		public var the_loader:Loader;

		public var main_target:Object;
		

		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public function App(in_client:Client, in_str_url:String, in_app_scale_x:Number, in_app_scale_y:Number, in_app_offset_x:int, in_app_offset_y:int, in_app_bg_color:String)
		{

			client = in_client;
			str_url = in_str_url;
			app_scale_x = in_app_scale_x;
			app_scale_y = in_app_scale_y;
			app_offset_x = in_app_offset_x;
			app_offset_y = in_app_offset_y;
			app_bg_color = (uint)(in_app_bg_color);

			the_loader = new Loader();		
			the_loader.contentLoaderInfo.addEventListener(Event.COMPLETE, handlerLoadComplete, false);
			the_loader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS,handlerLoadProgress,false);
			the_loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR,handlerLoadIOError,false);

			try
			{
				the_loader.load(new URLRequest("/apps/" + str_url));
			}
			catch(e:Error)
			{
				UtilLog.write("unable to load app:" + e);
							  
				shutdown();
			}
		}


		////////////////////////////////////////////////////////////////////////
		//
		////////////////////////////////////////////////////////////////////////
		public function shutdownExternallyLoadedApp():void
		{
						
			try
			{
				((Object)(main_target)).shutdown();
			}
			catch(e:Error)
			{
				//externally loaded class doesn't have this method
				//most likely cause it's a 3rd party app
			}
			
		}

		////////////////////////////////////////////////////////////////////////
		//
		////////////////////////////////////////////////////////////////////////
		public function shutdown():void
		{
			if (the_loader != null)
			{
				the_loader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR,handlerLoadIOError);
				the_loader.contentLoaderInfo.removeEventListener(ProgressEvent.PROGRESS,handlerLoadProgress);
				the_loader.contentLoaderInfo.removeEventListener(Event.COMPLETE, handlerLoadComplete);
			}

		}

		////////////////////////////////////////////////////////////////////////
		//
		////////////////////////////////////////////////////////////////////////
		private function handlerLoadProgress(event:ProgressEvent):void
		{

			if (Client.IS_DEBUG == true)
				trace("loading:" + event.bytesLoaded + ":" + event.bytesTotal);
		}
		
		////////////////////////////////////////////////////////////////////////
		//
		////////////////////////////////////////////////////////////////////////
		private function handlerLoadComplete(event:Event):void
		{
			if (Client.IS_DEBUG == true)
				trace("loading complete!");
			
			var do_request:Boolean = false;

			client.colorTopPanel(client.panel_top,app_bg_color);


			the_loader.scaleX = app_scale_x;
			the_loader.scaleY = app_scale_y;

			the_loader.x += app_offset_x;
			the_loader.y += app_offset_y;


			
			//add a clipping mask (to clip everything beynd the borders)
			var myMask:Sprite = new Sprite();
			myMask.graphics.beginFill(0x000000);
			myMask.graphics.drawRect(0, 0, the_loader.content.loaderInfo.width * app_scale_x,
									 	   the_loader.content.loaderInfo.height * app_scale_y);


			the_loader.mask = myMask;
			
			client.panel_top.addChild(the_loader);

			//checking if app has any requests to make of the db
			try
			{
				main_target = ((Object)(event.target.content));
				
				var str_request:String = ((Object)(event.target.content)).getRequestType();
				if (str_request != "")
					do_request = true;

			}
			catch(e:Error)
			{
				//this app doens't support that method - ie because
				//it was written by someone else
			}

			if (do_request == true)
			{

				//kick off request and start timer that will listen for
				//the request to finish
				var was_problem:Boolean = false;
				var str:String = str_request;
				
				if (str.indexOf("RequestGetQuizQuestions") != -1)
				{
					var col:Array = str.split(",");
					var req1:RequestGetQuizQuestions = new RequestGetQuizQuestions(client.getGroupId(),client.getUserId(),col[1],col[2]);
					req1.send(client);
				}
				else if (str == "RequestGetEmails")
				{
					var req2:RequestGetEmails = new RequestGetEmails(client.getUserName());
					req2.send(client);
				}
				else // not founnd
				{
					//there was an error - do don't kick the wait to finish
					//listner
					UtilLog.write("there was a problem with the apps request list");
					try
					{		
						((Object)(event.target.content)).doNotWaitForResponse();
					}
					catch(e:Error)
					{
						//externally loaded class doesn't have this method
						//most likely cause it's a 3rd party app
					}
				}
		
			}
			else
			{
				client.hideLoadingPanel();
			}
			
			shutdown();
		}
		
		
		////////////////////////////////////////////////////////////////////////
		//
		////////////////////////////////////////////////////////////////////////
		private function handlerLoadIOError(event:Event):void
		{
			UtilLog.write("error in loading app:" + event);
			
			shutdown();
		}

	}
}
