﻿package
{
	import flash.display.*;
	import flash.events.*;
	import flash.text.*;
	import flash.geom.*;
	
	import util.*;

	////////////////////////////////////////////////////////////////////////
	//
	////////////////////////////////////////////////////////////////////////
	public class AppsButton extends SimpleButton
	{
		private var client:Client;
				
		private var str_app_title:String = "Apps";

		private var up:Sprite = new Sprite();
		private var down:Sprite = new Sprite();


		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public function AppsButton(in_client:Client, in_stage:Stage)
		{
			
			client = in_client;
			
			drawSprites(in_stage);
		
			addText(in_stage);
		
			upState = up;
			overState = up;
			hitTestState = up;

			downState = down;
			
			enabled = true;
			useHandCursor = true;
		
			addEventListener(MouseEvent.CLICK, handlerWasClicked, false, 0 ,true);

		}
		
		///////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		private function drawSprites(in_stage:Stage):void
		{
			var g:Graphics;
			
			g = up.graphics;
			
			g.clear();

			g.beginFill(0xffffff);
			g.drawRoundRect(0,0,
							Icon.ICON_PLATE_WIDTH,Icon.ICON_PLATE_HEIGHT,
							30,30);
			g.endFill();			
			
			g.beginFill(0x2020a0);
			g.drawRoundRect(4,4,
							Icon.ICON_PLATE_WIDTH * 0.9,Icon.ICON_PLATE_HEIGHT * 0.9,
							30 * 0.9,30 * 0.9);
			g.endFill();			
			
			
			g.beginFill(0xff3050);
			g.drawRoundRect(12,10,
							Icon.ICON_PLATE_WIDTH * 0.4,Icon.ICON_PLATE_HEIGHT * 0.4,
							30 * 0.4,30 * 0.4);
			g.endFill();			

			g.beginFill(0x30ff50);
			g.drawRoundRect(37,20,
							Icon.ICON_PLATE_WIDTH * 0.4,Icon.ICON_PLATE_HEIGHT * 0.4,
							30 * 0.4,30 * 0.4);
			g.endFill();			

			g.beginFill(0xffff50);
			g.drawRoundRect(22,40,
							Icon.ICON_PLATE_WIDTH * 0.4,Icon.ICON_PLATE_HEIGHT * 0.4,
							30 * 0.4,30 * 0.4);
			g.endFill();			


			g = down.graphics;
			
			g.clear();
			g.beginFill(0xffffff);
			g.drawRoundRect(0,0,
							Icon.ICON_PLATE_WIDTH,Icon.ICON_PLATE_HEIGHT,
							30,30);
			g.endFill();			
			
			g.beginFill(0x2020a0);
			g.drawRoundRect(4,4,
							Icon.ICON_PLATE_WIDTH * 0.9,Icon.ICON_PLATE_HEIGHT * 0.9,
							30 * 0.9,30 * 0.9);
			g.endFill();			
			
			
			g.beginFill(0xff3050);
			g.drawRoundRect(12,10,
							Icon.ICON_PLATE_WIDTH * 0.4,Icon.ICON_PLATE_HEIGHT * 0.4,
							30 * 0.4,30 * 0.4);
			g.endFill();			

			g.beginFill(0x30ff50);
			g.drawRoundRect(37,20,
							Icon.ICON_PLATE_WIDTH * 0.4,Icon.ICON_PLATE_HEIGHT * 0.4,
							30 * 0.4,30 * 0.4);
			g.endFill();			

			g.beginFill(0xffff50);
			g.drawRoundRect(22,40,
							Icon.ICON_PLATE_WIDTH * 0.4,Icon.ICON_PLATE_HEIGHT * 0.4,
							30 * 0.4,30 * 0.4);
			g.endFill();			

			var col_xform:ColorTransform = new ColorTransform();
			col_xform.redMultiplier = 0.9;
			col_xform.greenMultiplier = 0.9;
			col_xform.blueMultiplier = 0.9;
	
			down.transform.colorTransform = col_xform;
			

		}
		
		///////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		private function addText(in_stage:Stage):void
		{
			var name_up:TextField = null;
			var name_down:TextField = null;
			
			name_up = new TextField();
			name_down = new TextField();
			
			name_up.width = 100;
			name_up.height = 30;
			
			name_up.text = "Apps";
			name_up.setTextFormat(client.text_format_main_icon);
			name_up.embedFonts = true;
			name_up.defaultTextFormat = client.text_format_main_icon;
			
			name_up.x = Icon.ICON_PLATE_WIDTH/2 - name_up.textWidth/2;
			name_up.y = Icon.ICON_PLATE_WIDTH + 8;
			
			
			up.addChild(name_up);
			
			name_down = UtilClone.cloneTextField(name_up);
			down.addChild(name_down);
		}

		///////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		private function handlerWasClicked(e:Event):void
		{
			if (client.areIconsFinishedLoading())
			{
				client.showCurrentIconsPage();
			}
			else
			{
				client.showLoadingPanel();
			}
		}
	}
}
