﻿package
{
	import flash.display.*;
	import flash.events.*;
	import flash.net.*;
	import flash.geom.*;

	import util.*;

	////////////////////////////////////////////////////////////////////////
	//
	////////////////////////////////////////////////////////////////////////
	public class AssetLoader
	{
		private var client:Client;
		private var the_size:Point;
		private var the_pos:Point;
		
		private var parent_obj:DisplayObjectContainer;
		
		private var fname_asset:String;
		
		private var loader:Loader;

		

		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public function AssetLoader(in_client:Client, in_fname_asset:String, in_parent_obj:DisplayObjectContainer, in_size_x:int, in_size_y:int, in_pos_x:int, in_pos_y:int)
		{
			client = in_client;
			fname_asset = in_fname_asset;
			parent_obj = in_parent_obj;
			the_size = new Point(in_size_x,in_size_y);
			the_pos = new Point(in_pos_x,in_pos_y);
	
			loader = new Loader();		
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, handlerLoadComplete, false);
			loader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS,handlerLoadProgress,false);
			loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR,handlerLoadIOError,false);
			
			try
			{
				loader.load(new URLRequest("/" + fname_asset));
			}
			catch(e:Error)
			{
				UtilLog.write("unable to load asset:" + fname_asset + ":" + e);
							  
				shutdown();
			}
		
		}
		
		///////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		private function shutdown():void
		{
			if (loader)
			{
				if (loader.contentLoaderInfo.hasEventListener(Event.COMPLETE))
					loader.contentLoaderInfo.removeEventListener(Event.COMPLETE, handlerLoadComplete);
				
				if (loader.contentLoaderInfo.hasEventListener(ProgressEvent.PROGRESS))
					loader.contentLoaderInfo.removeEventListener(ProgressEvent.PROGRESS,handlerLoadProgress);

				if (loader.contentLoaderInfo.hasEventListener(IOErrorEvent.IO_ERROR))
					loader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR,handlerLoadIOError);
			}
		}
		
		
		
		////////////////////////////////////////////////////////////////////////
		//
		////////////////////////////////////////////////////////////////////////
		private function handlerLoadProgress(event:ProgressEvent):void
		{
		}
		
		////////////////////////////////////////////////////////////////////////
		//
		////////////////////////////////////////////////////////////////////////
		private function handlerLoadComplete(event:Event):void
		{
			event.target.loader.width = the_size.x;
			event.target.loader.height = the_size.y;
			
			event.target.loader.x = the_pos.x;
			event.target.loader.y = the_pos.y;

			parent_obj.addChild(event.target.loader);
			
			shutdown();
		}
		
		
		////////////////////////////////////////////////////////////////////////
		//
		////////////////////////////////////////////////////////////////////////
		private function handlerLoadIOError(event:Event):void
		{
			UtilLog.write("error in loading asset:" + fname_asset + ":" + event);
			
			shutdown();
		}

	}
}
