package
{
	import flash.display.*;
	import flash.events.*;
	import flash.utils.*;
	import flash.system.*;
	import flash.geom.*;
	import flash.text.*;
	import flash.filters.*;
	import flash.media.*;
	import flash.net.*;

	import request.*;
	import response.*;
	import util.*;
	
	/////////////////////////////////////////////////////
	//
	/////////////////////////////////////////////////////
	public class Client extends MovieClip
	{
		[Embed(source="images/logo_sparkmarble.png")] private var LogoSparkMarbleImage:Class;
		[Embed(source="images/logo_moodle.png")] private var LogoMoodleImage:Class;

		public static var IS_PROD:Boolean = false;
		public static var IS_DEBUG:Boolean = true;
		private static var VERSION:String = "1.7";

		private var java_server_address:String;
		private var java_server_port:uint;
		
		private var timer_update:Timer;
		private var timer_fade:Timer = null;
		private var timer_load_update:Timer = null;
		private var timer_icons_loaded:Timer = null;
		private var first_time_load:Boolean = true;
		private var list_response:Array = new Array();

		private var list_icon:Array = new Array();
		private var current_icons_page:int = 0;
		private var are_icons_finished_loading:Boolean = false;

		public var panel_top:Sprite;
		private var panel_bottom:Sprite;
		private var panel_loading:Sprite;

		public var text_format_main_icon:TextFormat;
		public var text_format_version:TextFormat;
		
		private var textfield_label_version:TextField;
				
		var list_sprite_loading_circle:Array = new Array();
		var sprite_loading_bar:Sprite;
		private static const PROGRESS_BAR_WIDTH:int     = 200;
		private static const PROGRESS_BAR_HEIGHT:int     = 40;
		var pct_loaded:Number = 0.0;

		public var current_app:App = null;

		private var username:String = null;
		private var user_id:String = null;
		private var group_id:String = null;
		
		///private var spend_seconds:Boolean = false;
		
		private var list_course:Array = new Array();
		
		private var is_bootup:Boolean = false;
		
		public static var URL_ERROR_PAGE:String = "error.php";

		
		/////////////////////////////////////////////////////
		//
		/////////////////////////////////////////////////////
		public function Client()
		{
			//wait for stage to be loaded
			this.addEventListener(Event.ADDED_TO_STAGE, setup);
		}


		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		private function setup(event:Event):void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, setup);

			//get group id from url parameters
			group_id = root.loaderInfo.parameters.group_id; 

			URL_ERROR_PAGE += "?group_id=" + group_id;

			//make sure this swf can only run from the sparkmarble.com
			//server if it's in prod
			if (IS_PROD == true)
			{
				if (this.root.loaderInfo.url.indexOf("sparkmarble.com") == -1)
				{
					trace("ERROR: sorry, this swf can only run from its original domain");
					navigateToURL(new URLRequest(URL_ERROR_PAGE),"_self");
					return;
				}
			}


			stage.align=StageAlign.TOP;
			
			if (IS_PROD == true)
			{
				java_server_address = "game.sparkmarble.com";
				java_server_port = 80;
			}
			else
			{
				java_server_address = "127.0.0.1";
				java_server_port = 33337;
			}

			
			UtilLog.write("starting client against " + java_server_address + ":" + java_server_port);

			setupFonts();

			createLoadingPanel();
			showLoadingPanel(true);
			
			createTopPanel();
			createBottomPanel();
			
			timer_icons_loaded = new Timer(1000);
			timer_icons_loaded.addEventListener(TimerEvent.TIMER, checkForIconsLoaded);
			timer_icons_loaded.start();

			//create main update looper
			stage.frameRate = 30;
			timer_update = new Timer(33);
			timer_update.addEventListener(TimerEvent.TIMER, update);
			timer_update.start();

			//send client info
			var req_ci:RequestSendClientInfo;
			req_ci = new RequestSendClientInfo();
			req_ci.send(this);

			//get list of app info
			var req:RequestGetAppInfo;
			req = new RequestGetAppInfo();
			req.send(this);

		}
		
		

		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		private function setupFonts():void
		{
			//instantiate font class to pull in fonts
			new ClientFonts();

			//create text formats
			text_format_main_icon = new TextFormat();
			text_format_main_icon.color = 0xffffff;
			text_format_main_icon.size = 14;
			text_format_main_icon.font = "font_main";
				
			text_format_version = new TextFormat();
			text_format_version.color = 0xf0f050;
			text_format_version.size = 10;
			text_format_version.font = "font_main";
		
		}
			
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		private function createTopPanel():void
		{
			var g:Graphics;
			
			panel_top = new Sprite();
		
			colorTopPanel(panel_top,0x202020);

			this.addChild(panel_top);
			panel_top.y = 0;
			
		}
		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function colorTopPanel(s:Sprite, col:uint):void
		{
			var g:Graphics = s.graphics;
			g.clear();
			g.beginFill(col);
			g.drawRect(0,0,800,480);
			g.endFill();			
		}
			
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		private function createBottomPanel():void
		{
			var i:int;
			var j:int;
			var g:Graphics;
			
			var colors:Array = new Array();
			var alphas:Array = new Array();
			var ratios:Array = new Array();

			panel_bottom = new Sprite();
		
			colors.push(0xffffff);
			colors.push(0x808080);
			
			alphas.push(1.0);
			alphas.push(1.0);

			ratios.push(0);
			ratios.push(255);

			var mat:Matrix = new Matrix();
			mat.createGradientBox(400,300,-1.57,0,0);	

			g = panel_bottom.graphics;
			g.clear();
			g.beginGradientFill(GradientType.LINEAR,
								colors,
								alphas,
								ratios,
								mat,
								SpreadMethod.PAD,
					       		InterpolationMethod.RGB,
					       		0.0);
			g.drawRect(0,0,800,102);
			g.endFill();			
			
			g.beginFill(0x808080);
			g.drawRect(0,102,800,120);
			g.endFill();			
			
			//draw dot pattern
			var num_across:int;
			var num_down:int;
			
			num_across = 800/4;
			num_down = 102/4;
			
			var dot_width:int;
			
			dot_width = 800 / (num_across * 2);
		
			for(i=1;i<num_across;i++)
			{
				for(j=1;j<num_down + 1;j++)
				{
					var doit:Boolean = true;
					
					if (j%2 == 0)
					{
						if (i == 1 || i == num_across - 1)
							doit = false;
					}
					
					if (doit)
					{
						g.beginFill(0xffffff);
					
						g.drawCircle(i * (dot_width * 2),
								   j * (dot_width * 2),
								   dot_width/2);
			
						g.endFill();			
			
						g.beginFill(0x303030);
						
						g.drawCircle(i * (dot_width * 2),
								   j * (dot_width * 2) - (dot_width/3),
								   dot_width/2);
				
						g.endFill();			
					}
				}
			}
			
			
			//make version label
			textfield_label_version = new TextField();
			textfield_label_version.text = VERSION;
			textfield_label_version.setTextFormat(text_format_version);
			textfield_label_version.embedFonts = true;
			textfield_label_version.defaultTextFormat = text_format_version;
			textfield_label_version.x = 3;
			textfield_label_version.y = 104;
			panel_bottom.addChild(textfield_label_version);
							
			
			this.addChild(panel_bottom);
			panel_bottom.y = 480;
			panel_bottom.cacheAsBitmap = true;
		}
		
		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		private function createLoadingPanel():void
		{
			var g:Graphics;
			var i:int;
			var cols:Array;
			var size:int;

			panel_loading = new Sprite();
		
			panel_loading.x = 0;
			panel_loading.y = 0;
			
			//add box sprites
			var filter:BitmapFilter = new GlowFilter( 0xffffff,
									  1.0,
									  16,
									  16,
									  2,
									  BitmapFilterQuality.LOW,
									  false,
									  false);

			var myFilters:Array = new Array();
			myFilters.push(filter);


			var sprite_loading_background:Sprite = new Sprite();

			sprite_loading_background.x = 0;
			sprite_loading_background.y = 0;

//			sprite_loading_background.graphics.beginFill(0x303030);
			sprite_loading_background.graphics.beginFill(0xffffff);
			
			sprite_loading_background.graphics.lineStyle(5,0x202020);
			sprite_loading_background.graphics.drawRect(0,0,800,600);
			sprite_loading_background.graphics.endFill();

			panel_loading.addChild(sprite_loading_background);

			var sp_logo_1:Sprite = new Sprite();
			sp_logo_1.addChild(new LogoSparkMarbleImage());
			var sp_logo_2:Sprite = new Sprite();
			sp_logo_2.addChild(new LogoMoodleImage());
			sp_logo_1.x = 140;
			sp_logo_1.y = 30;
			sp_logo_2.x = 500;
			sp_logo_2.y = 120;
			panel_loading.addChild(sp_logo_1);
			panel_loading.addChild(sp_logo_2);


			for(i=0;i<3;i++)
			{
				list_sprite_loading_circle[i] = new Sprite();
				list_sprite_loading_circle[i].filters = myFilters;
				list_sprite_loading_circle[i].graphics.clear();
				list_sprite_loading_circle[i].graphics.lineStyle(0,0xffffff);
				
				size = 200 - (i * 50);
				
				if (i == 0)
					cols = [0xaaaaaa, 0x444444];
				else if (i == 1)
					cols = [0x555555, 0x444444];
				else
					cols = [0xffff00, 0x80ff00];
				
				if (i == 2)
				{
					list_sprite_loading_circle[i].graphics.beginGradientFill(GradientType.LINEAR,
						 cols,
						 [1.0, 1.0],
						 [0x0, 0xff]);

				}
				else
				{
					list_sprite_loading_circle[i].graphics.beginGradientFill(GradientType.LINEAR,
										 cols,
										 [0.6, 0.6],
										 [0x0, 0xff]);
				}
				list_sprite_loading_circle[i].graphics.drawRoundRect(-size/2,-size/2,size,size,size * .60);
				list_sprite_loading_circle[i].graphics.endFill();
				list_sprite_loading_circle[i].x = 400;
				list_sprite_loading_circle[i].y = 300;
				sprite_loading_background.addChild(list_sprite_loading_circle[i]);

                sprite_loading_bar = new Sprite();
                sprite_loading_bar.filters = myFilters;
                drawLoadingBar(pct_loaded);
				sprite_loading_bar.x = 300;
				sprite_loading_bar.y = 450;
				sprite_loading_background.addChild(sprite_loading_bar);

			}
		}
		
		
        ///////////////////////////////////////////////////////////////////////////
        //
        //
        ///////////////////////////////////////////////////////////////////////////
        private function drawLoadingBar(pct:Number):void
        {

            if (pct < 0.0)
                pct = 0.0;
            else if (pct > 1.0)
                pct = 1.0;

            if (sprite_loading_bar == null)
                return;

            sprite_loading_bar.graphics.clear();

            sprite_loading_bar.graphics.beginFill(0x243e6e);
            sprite_loading_bar.graphics.lineStyle(1,0xffffff);
            sprite_loading_bar.graphics.drawRect(0,0,PROGRESS_BAR_WIDTH,PROGRESS_BAR_HEIGHT);
            sprite_loading_bar.graphics.endFill();

            //draw progress bar
            sprite_loading_bar.graphics.beginFill(0xa7d8ec);
            sprite_loading_bar.graphics.lineStyle(5,0xffffff);
            sprite_loading_bar.graphics.drawRect(0,0,PROGRESS_BAR_WIDTH * pct,PROGRESS_BAR_HEIGHT);
            sprite_loading_bar.graphics.endFill();
        
            //draw top cover
            sprite_loading_bar.graphics.lineStyle(5,0x6798ac);
            sprite_loading_bar.graphics.drawRoundRect(0,0,PROGRESS_BAR_WIDTH,PROGRESS_BAR_HEIGHT,10,10);
            sprite_loading_bar.graphics.endFill();


        }        


		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function showLoadingPanel(in_is_bootup:Boolean = false):void
		{
			is_bootup = in_is_bootup;
			
			if (timer_load_update != null)
			{
				timer_load_update.removeEventListener(TimerEvent.TIMER, updateLoad);
				timer_load_update.stop();
				timer_load_update = null
			}
			
			timer_load_update = new Timer(33);
			timer_load_update.addEventListener(TimerEvent.TIMER, updateLoad);
			timer_load_update.start();
		}
		
		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function hideLoadingPanel():void
		{
			//start a timer event that fades the loading panel out
			if (timer_fade != null)
			{
				timer_fade.removeEventListener(TimerEvent.TIMER, updateFade);
				timer_fade.stop();
				timer_fade = null
			}
			
			timer_fade = new Timer(33);
			timer_fade.addEventListener(TimerEvent.TIMER, updateFade);
			timer_fade.start();

		}
		
		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		private function updateLoad(event:Event):void
		{
			if (panel_loading.parent == null && 
				(timer_load_update.currentCount >= 0 || first_time_load == true))
			{
				first_time_load = false;
				panel_loading.alpha = 1.0;
				this.addChild(panel_loading);
			}
			
			if (panel_loading.parent != null)
			{
				var i:int;
	
				for(i=0;i<list_sprite_loading_circle.length;i++)
				{
					if (i == 0)
						list_sprite_loading_circle[i].rotation += 5;
					else if (i == 1)
						list_sprite_loading_circle[i].rotation -= 5;
					else //
						list_sprite_loading_circle[i].rotation += 5;
	
				}


				//update status of loader bar
				if (sprite_loading_bar != null && list_icon.length > 0)
				{
					var last_pct:Number = pct_loaded;
					
					var cnt:int = 0;
					var icon:Icon; 
					for(i=0;i<list_icon.length;i++)
					{
						icon = list_icon[i];
						if (icon.isLoaded())
							cnt++;
					}

					//if bootup relates directly to
					//the 3 second delay of the socket policy file
					//
					// This loading bar accounts for the flash socket policy file:
					//
					// Since the Flash Player always tries port 843 first, if there's
					// nothing listening on that port, (AND WE CAN'T BECAUSE
					// MOST SCHOOLS WILL ONLY HAVE PORT 80 OPEN) then the Flash clients
					// are going to experience a 3-second delay when trying to connect
					// to your server.

					if (is_bootup == true)
					{
						if (cnt == 0)
						{
							if (pct_loaded < 0.5)
								pct_loaded += 0.1;
						}
						else
						{
							pct_loaded = 0.5 + (cnt/list_icon.length) * 0.5;
						}

					}
					else
					{
						pct_loaded = cnt/list_icon.length;
					}
				

					if (pct_loaded > last_pct)
						drawLoadingBar(pct_loaded);
				}

			}


		}
		
		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		private function updateFade(event:Event):void
		{
			panel_loading.alpha -= 0.30;
			if (panel_loading.alpha <= 0.0)
			{
				timer_fade.stop();
				timer_fade.removeEventListener(TimerEvent.TIMER, updateFade);
				timer_fade = null;
			
				if (panel_loading.parent == this)
					this.removeChild(panel_loading);
			
			
				if (timer_load_update != null)
				{
					timer_load_update.removeEventListener(TimerEvent.TIMER, updateLoad);
					timer_load_update.stop();
					timer_load_update = null
				}
				
			}


		}
		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function setupNavBarIcons():void
		{
			createNavBarIcons();			
			
		}
		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		private function checkForIconsLoaded(event:Event):void
		{
			var i:int;
			var icon:Icon;


			if (list_icon.length < 1)
				return;

			for(i=0;i<list_icon.length;i++)
			{
				icon = list_icon[i];
				if (!(icon.isLoaded()))
					return;
			}

			if (group_id != null)
			{
				var swf_name:String;
				swf_name =  "Login/Login.swf";
				showLoadingPanel();
				loadApp(swf_name,1.0,1.0,0,0,"0x000000");
			}
			else
			{
				setupNavBarIcons();
				showCurrentIconsPage();
			}
			
			setIconsFinishedLoading();

			timer_icons_loaded.stop();
			timer_icons_loaded.removeEventListener(TimerEvent.TIMER, checkForIconsLoaded);
			timer_icons_loaded = null;
			
		}

		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		private function createNavBarIcons():void
		{
			var icon:Icon;
			var apps_button:AppsButton;
			
//			icon = new Icon(this,"Email","email",1.0,1.0,0,0,"0xffffff",true);
//			panel_bottom.addChild(icon);
//			icon.x = 70;
//			icon.y = 12;
//			icon.setMask(panel_bottom.x, panel_bottom.y);

			apps_button = new AppsButton(this,stage);	
			if (group_id != null)
				apps_button.x = 230;
			else
				apps_button.x = 350;
			apps_button.y = 12;
			panel_bottom.addChild(apps_button);

			if (group_id != null)
			{
				icon = new Icon(this,"Quiz","quizPicker",1.0,1.0,0,0,"0xffffff",true);
				panel_bottom.addChild(icon);
				icon.x = 500;
				icon.y = 12;
				icon.setMask(panel_bottom.x, panel_bottom.y);
			}

		}	
		

		
		//////////////////////////////////////////////////////////////////////////////////////////
		//
		//  
		//////////////////////////////////////////////////////////////////////////////////////////
		public function addIcon(icon:Icon):void
		{
			list_icon.push(icon);
		}

		//////////////////////////////////////////////////////////////////////////////////////////
		//
		//  
		//////////////////////////////////////////////////////////////////////////////////////////
		public function showCurrentIconsPage():void
		{
			var i:int;
		
			colorTopPanel(panel_top,0x202020);
			
			clearCurrentApp();
			
			hideCurrentIconsPage();

			if (current_icons_page != 0)
			{
				UtilLog.write("only supporting one icons page for now");
				current_icons_page = 0;
			}

			var curr_row:int = -1;
			var curr_col:int = 0;
			
			var pos_x:int;
			var pos_y:int;
			
			var icon:Icon;

			var num_icons_across = 6;
			var num_icons_down = 3;

			//loop through the apps and add them to the top panel
			//at proper x/y pos based on ratios
			for(i=0;i<list_icon.length;i++)
			{
				if (i%num_icons_across == 0)
				{
					curr_row++;
					
					if (curr_row >= num_icons_down)
					{
						UtilLog.write("too many apps on desktop - only supporting one page now");
						return;
					}
					
					curr_col = 0;
				}
				
				pos_x = ((800) * (curr_col/num_icons_across)) + (26);		
				pos_y = ((480) * (curr_row/num_icons_down)) + (24);
				
				icon = list_icon[i];
				panel_top.addChild(icon);
				icon.x = pos_x;
				icon.y = pos_y;
				icon.setMask();
				
				curr_col++;
			}
			
			hideLoadingPanel();

		}

		//////////////////////////////////////////////////////////////////////////////////////////
		//
		//  
		//////////////////////////////////////////////////////////////////////////////////////////
		private function clearCurrentApp():void
		{
			if (current_app != null)
			{
				current_app.shutdown();
				current_app.shutdownExternallyLoadedApp();
				
				if (current_app.the_loader != null)
					current_app.the_loader.unload();
				
				if (current_app.the_loader)
				{
					if (current_app.the_loader.parent == panel_top)
					{
						panel_top.removeChild(current_app.the_loader);
					}
				}

				current_app = null;
				
				//var mySoundTransform:SoundTransform = new SoundTransform();
				//mySoundTransform.volume = 0;    
				//SoundMixer.soundTransform = mySoundTransform;
				SoundMixer.stopAll();    

				if (IS_DEBUG)
				{
					var mem:String = Number( System.totalMemory / 1024 / 1024 ).toFixed( 2 );
					trace("mem:" + mem);
				}
			}

		}
		
		//////////////////////////////////////////////////////////////////////////////////////////
		//
		//  
		//////////////////////////////////////////////////////////////////////////////////////////
		public function hideCurrentIconsPage():void
		{
			var i:int;
			
			if (current_icons_page != 0)
			{
				UtilLog.write("only supporting one icons page for now");
				current_icons_page = 0;
			}
			
			var icon:Icon;

			for(i=0;i<list_icon.length;i++)
			{
				icon = list_icon[i];
				
				if (icon.parent == panel_top)
					panel_top.removeChild(icon);
			}
		}

		
		//////////////////////////////////////////////////////////////////////////////////////////
		//
		//  
		//////////////////////////////////////////////////////////////////////////////////////////
		public function loadApp(str_app_name:String, app_scale_x:Number, app_scale_y:Number, app_offset_x:int, app_offset_y:int, app_bg_color:String):void
		{
			
			hideCurrentIconsPage();
	
			clearCurrentApp();
			var a:App = new App(this,str_app_name, app_scale_x, app_scale_y, app_offset_x, app_offset_y, app_bg_color);		
			current_app = a;
  
		}
		

		//////////////////////////////////////////////////////////////////////////////////////////
		//
		//  
		//////////////////////////////////////////////////////////////////////////////////////////
		protected function update(evt:Event):void
		{
			//process responses
			if (list_response.length < 1)
				return;
			
			var rsp:Response;
				
			while(list_response.length > 0)
			{
				//rsp = list_response.shift();
				rsp = list_response.pop();
				
				rsp.process();
			}


		}
		
	
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function login(str_username:String, str_password:String):void
		{
			var req:RequestLogin;
			req = new RequestLogin(group_id,str_username,str_password);
			req.send(this);
		
		}
		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function sendQuizResults(str:String):void
		{
			var req:RequestSendQuizResults;
			req = new RequestSendQuizResults(group_id,str);
			req.send(this);
		}
		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function addCourse(course_name:String):int
		{
			var course_idx:int;
			
			var course:Course = new Course(course_name);
			course_idx = list_course.push(course) - 1;
			
			return course_idx;
		}
		
		

		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function addQuiz(course_idx:int, quiz_id:int, course_module_id:String, quiz_name:String, quiz_desc:String):void
		{
			var course:Course = list_course[course_idx];
			
			var quiz:Quiz = new Quiz(quiz_id,course_module_id,quiz_name,quiz_desc);
			
			course.addQuiz(quiz);
		}


		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function getNumCourses():int
		{
			return list_course.length;
		}
		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function getCourseName(idx_course:int):String
		{
			return list_course[idx_course].str_name;
		}
		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function getNumQuizzes(idx_course:int):String
		{
			return list_course[idx_course].list_quiz.length;
		}
		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function getQuizId(idx_course:int,idx_quiz:int):String
		{
			return list_course[idx_course].list_quiz[idx_quiz].id;
		}
		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function getCourseModuleId(idx_course:int,idx_quiz:int):String
		{
			return list_course[idx_course].list_quiz[idx_quiz].course_module_id;
		}
		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function getQuizName(idx_course:int,idx_quiz:int):String
		{
			return list_course[idx_course].list_quiz[idx_quiz].str_name;
		}
		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function getQuizDesc(idx_course:int,idx_quiz:int):String
		{
			return list_course[idx_course].list_quiz[idx_quiz].str_desc;
		}
		


		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function startQuizPicker():void
		{
			var swf_name:String =  "quizPicker/quizPicker.swf";
			
			showLoadingPanel();
			
			//tell client to load new app
			loadApp(swf_name,1.0,1.0,0,0,"0xffffff");
			
		}
		

		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function startQuiz(quiz_id:String, course_module_id:String):void
		{
			var swf_name:String =  "QuestionFury/QuestionFury.swf?quiz_id=" + quiz_id + "&course_module_id=" + course_module_id;
			
			showLoadingPanel();
			
			//tell client to load new app
			loadApp(swf_name,1.143,1.1979,0,0,"0xffffff");
			
		}
		
		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function addToResponseQueue(rsp:Response):void { list_response.push(rsp); }
		public function setIconsFinishedLoading():void { are_icons_finished_loading = true; }
		public function setUserName(val:String):void { username = val; }
		public function setUserId(val:String):void { user_id = val; }
		
		
		///////////////////////////////////////////////////////////////////////////
		//
		//
		///////////////////////////////////////////////////////////////////////////
		public function getJavaServerAddress():String { return java_server_address; }
		public function getJavaServerPort():uint { return java_server_port; }
		public function areIconsFinishedLoading():Boolean { return are_icons_finished_loading; }
		public function getUserName():String { return username; }
		public function getGroupId():String { return group_id; }
		public function getUserId():String { return user_id; }
		
	}
}