﻿package
{
	import flash.display.*;
	import flash.events.*;
	import flash.text.*;
	import flash.net.*;
	import flash.geom.*;

	import util.*;

	////////////////////////////////////////////////////////////////////////
	//
	////////////////////////////////////////////////////////////////////////
	public class Icon extends SimpleButton
	{
		private var client:Client;
				
		private var str_app_title:String;
		private var str_app_name:String;
	
		private var up:Sprite = new Sprite();
		private var down:Sprite = new Sprite();
		private var loader:Loader;

		public static var ICON_PLATE_WIDTH:int = 80;
		public static var ICON_PLATE_HEIGHT:int = 80;
	
		public static var ICON_WIDTH:int = 80;
		public static var ICON_HEIGHT:int = 80;
	
		private var app_scale_x:Number;
		private var app_scale_y:Number;

		private var app_offset_x:int;
		private var app_offset_y:int;
		
		private var app_bg_color:String;
		

		////////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public function Icon(in_client:Client, in_str_app_title:String, in_str_app_name:String, in_app_scale_x:Number, in_app_scale_y:Number, in_app_offset_x:int, in_app_offset_y:int, in_app_bg_color:String, is_nav_bar_icon:Boolean = false)
		{
			
			//NOTE: icon art file = apps/confetti/confetti_icon.swf
			//		app name      = apps/confetti/confetti.swf
		
			client = in_client;
			str_app_title = in_str_app_title;
			str_app_name = in_str_app_name;
			
			app_scale_x = in_app_scale_x;
			app_scale_y = in_app_scale_y;

			app_offset_x = in_app_offset_x;
			app_offset_y = in_app_offset_y;

			app_bg_color = in_app_bg_color;
			
			drawBackground(client.stage);
		
			addText(client.stage,is_nav_bar_icon);
		
			upState = up;
			overState = up;
			hitTestState = up;

			downState = down;
			
			//up.mouseChildren = false;
			//down.mouseChildren = false;

			
			enabled = true;
			useHandCursor = true;
		
			addEventListener(MouseEvent.CLICK, handlerWasClicked, false, 0 ,true);

			var fname_asset:String;
			var the_x:int;
			var the_y:int;
			
			the_x = 1;
			the_y = 1;
		
			fname_asset = "apps/" + str_app_name + "/" + str_app_name + "_icon.swf";
			var loader_up:AssetLoader = new AssetLoader(client,fname_asset, up,
														ICON_WIDTH,ICON_WIDTH,
														the_x,the_y);
			fname_asset = "apps/" + str_app_name + "/" + str_app_name + "_icon.swf";
			var loader_down:AssetLoader = new AssetLoader(client,fname_asset, down,
														ICON_WIDTH,ICON_WIDTH,
														the_x,the_y);
			

		}



		///////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public function setMask(x_off:int = 0, y_off:int = 0):void
		{
			//CANT GET MASKS TO WORK PROPERLY
			//if you add the masks back in - you won't be able to
			//click the icons (for some reason the first one works..)
			return;
			
			//skip out if it already has a mask
			if (up.mask != null || down.mask != null)
				return;
				
			//add a clipping mask (to clip everything beynd the borders)
			var myMask:Sprite = new Sprite();
			myMask.graphics.beginFill(0x000000);

			myMask.graphics.drawRoundRect(x_off,y_off,
							ICON_PLATE_WIDTH,ICON_PLATE_HEIGHT,
							30,30);
			myMask.graphics.drawRect(x_off + - 10,y_off + ICON_PLATE_WIDTH + 5,120,30);

			myMask.graphics.endFill();
			up.addChild(myMask);
			myMask.x = up.x;
			myMask.y = up.y;
			up.mask = myMask;
			//up.cacheAsBitmap = false;
			
			var myMask2:Sprite = new Sprite();
			myMask2.graphics.beginFill(0x000000);
			myMask2.graphics.drawRoundRect(x_off,y_off,
							ICON_PLATE_WIDTH,ICON_PLATE_HEIGHT,
							30,30);
			myMask2.graphics.drawRect(x_off - 10,y_off + ICON_PLATE_WIDTH + 5,120,30);
		
			down.addChild(myMask2);
			myMask2.x = down.x;
			myMask2.y = down.y;
			down.mask = myMask2;
			//down.cacheAsBitmap = false;

			
			var col_xform:ColorTransform = new ColorTransform();
			col_xform.redMultiplier = 0.9;
			col_xform.greenMultiplier = 0.9;
			col_xform.blueMultiplier = 0.9;

			down.transform.colorTransform = col_xform;
			
		}
		
		///////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		private function drawBackground(in_stage:Stage):void
		{
			/*
			var g:Graphics;
			
			g = up.graphics;
			
			g.clear();
			g.beginFill(0xffffff);
			g.drawRoundRect(0,0,
							ICON_PLATE_WIDTH,ICON_PLATE_HEIGHT,
							30,30);
			
			g.endFill();			
			

			g = down.graphics;
			
			g.clear();
			g.beginFill(0xe5e5e5);
			g.drawRoundRect(0,0,
							ICON_PLATE_WIDTH,ICON_PLATE_HEIGHT,
							30,30);
			
			g.endFill();			
			*/
		}

		///////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		private function handlerWasClicked(e:Event):void
		{
			var swf_name:String;

			swf_name =  str_app_name + "/" + str_app_name + ".swf";

			client.showLoadingPanel();

			//tell client to load new app
			client.loadApp(swf_name,app_scale_x,app_scale_y,app_offset_x,app_offset_y,app_bg_color);

		}
		
		
		///////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		private function addText(in_stage:Stage, is_nav_bar_icon:Boolean):void
		{
			var name_up:TextField = null;
			var name_down:TextField = null;
			
			name_up = new TextField();
			
			name_up.width = 120;
			name_up.height = 30;
			
			name_up.text = str_app_title;
			name_up.setTextFormat(client.text_format_main_icon);
			name_up.embedFonts = true;
			name_up.defaultTextFormat = client.text_format_main_icon;
			
			
			if (is_nav_bar_icon)
			{
				name_up.x = ICON_PLATE_WIDTH/2 - name_up.textWidth/2;
				name_up.y = ICON_PLATE_HEIGHT + 8;
			}
			else
			{
				name_up.x = ICON_PLATE_WIDTH/2 - name_up.textWidth/2;
				name_up.y = ICON_PLATE_HEIGHT + 5;
			}
			
			up.addChild(name_up);
			
			name_down = UtilClone.cloneTextField(name_up);
			down.addChild(name_down);
			
		}

		///////////////////////////////////////////////////////////////////////
		//
		//
		//
		////////////////////////////////////////////////////////////////////////
		public function isLoaded():Boolean
		{
			if (up.numChildren > 1 &&
				down.numChildren > 1)
			{
				return true;
			}
			
			return false;
			
		}
			
	}
}
