package config;

import java.io.*;
import java.util.*;

///////////////////////////////////////////////////////////////////////
//
//
///////////////////////////////////////////////////////////////////////
public class Config
{
	private static Properties file;

	public static int port;
	public static int max_threads;
	public static boolean is_log_active;
	public static String log_file;
	public static int max_log_file_length;
	public static String db_info;
	public static String db_username;
	public static String db_password;
	public static String email_for_logging;
	
	
	///////////////////////////////////////////////////////////////////////
	//
	//
	///////////////////////////////////////////////////////////////////////
	public static void setFile(String fname_props) throws Exception
	{
		file = new Properties();
		FileInputStream fs = new FileInputStream(new File(fname_props));
		file.load(fs);

		load();
	}


	///////////////////////////////////////////////////////////////////////////
	//
	///////////////////////////////////////////////////////////////////////////
	private static void load() throws Exception
	{
		port = getPropInt("port");
		max_threads = getPropInt("max_threads");
		is_log_active = getPropBoolean("is_log_active");
		log_file = getProp("log_file");
		max_log_file_length = getPropInt("max_log_file_length");
		db_info = getProp("db_info");
		db_username = getProp("db_username");
		db_password = getProp("db_password");
		email_for_logging = getProp("email_for_logging");

	}
	

	///////////////////////////////////////////////////////////////////////////
	//
	///////////////////////////////////////////////////////////////////////////
	private static String getProp(String prop) throws Exception
	{
		//return prop from file
		return file.getProperty(prop).trim();
	}


	///////////////////////////////////////////////////////////////////////////
	//
	///////////////////////////////////////////////////////////////////////////
	private static int getPropInt(String prop) throws Exception
	{
		return new Integer(getProp(prop)).intValue();
	}

	///////////////////////////////////////////////////////////////////////////
	//
	///////////////////////////////////////////////////////////////////////////
	//private static float getPropFloat(String prop) throws Exception
	//{
	//	return new Float(getProp(prop)).floatValue();
	//}

	///////////////////////////////////////////////////////////////////////////
	//
	///////////////////////////////////////////////////////////////////////////
	private static boolean getPropBoolean(String prop) throws Exception
	{
		return new Boolean(Config.getProp(prop)).booleanValue();
	}


}
