
package db;

import java.sql.*;

import config.*;

//////////////////////////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////////////////////////
public class Database
{

	private String db_url;
	private Connection conn = null;
	
	   
	//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
    public Database() throws Exception
    {
    	db_url = "jdbc:mysql://" + Config.db_info;
    
		try
		{
			Class.forName("com.mysql.jdbc.Driver");
						
			//get connection to database
			conn = DriverManager.getConnection(db_url,Config.db_username,Config.db_password);

		}
		catch (Exception e)
		{
			System.out.println("Failure:");
			System.out.println("    Url: " + db_url);
			System.out.println("    Username: " + Config.db_username);
			System.out.println("    Password: " + Config.db_password);
			System.out.println("    Error: " + e.getMessage());
			e.printStackTrace();
		}

    }


	//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
    public void shutdown() throws Exception
    {
		try
		{
			
			if(conn != null)
			{
				conn.close();
				conn = null;
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
    
    
    }
    
    
	//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
    public ResultSet callRead(String str_sql) throws Exception
    {
		Statement stmt = conn.createStatement();
		ResultSet rs;

		rs = stmt.executeQuery(str_sql);

		return rs;

    }
    
//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
    public void callWrite(String str_sql) throws Exception
    {
    	Statement statement = conn.createStatement();
    	statement.executeUpdate(str_sql);
      }

}

