
package request;

import java.sql.*;

import db.*;
import response.*;
import util.UtilLog;

//////////////////////////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////////////////////////
public class RequestGetAppInfo extends Request
{

	//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
    public RequestGetAppInfo(byte[] in_data)
    {
    	super(in_data);

    	id = Request.ID_GET_APP_INFO;
    }

	//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
    public byte[] process() throws Exception
    { 

    	Response rsp = new Response(Request.ID_GET_APP_INFO);

    	ResultSet rs;
    	
    	Database db = new Database();
    	
    	StringBuffer str = new StringBuffer();

    	try
    	{
	    	rs = db.callRead("select * from apps");	
	  	
    	 
	    	while (rs.next())
			{
	    		if (str.length() > 0)
	    			str.append(",");
	
	    		String name = rs.getString("name"); 
			    String swf_name = rs.getString("swf_name");
			    Float scale_x = rs.getFloat("scale_x");
			    Float scale_y = rs.getFloat("scale_y");
			    Integer offset_x = rs.getInt("offset_x");
			    Integer offset_y = rs.getInt("offset_y");
			    String bg_color = rs.getString("bg_color");
			    
			    str.append(name);
			    str.append(":");
			    str.append(swf_name);
			    str.append(":");
			    str.append(scale_x);
			    str.append(":");
			    str.append(scale_y);
			    str.append(":");
			    str.append(offset_x);
			    str.append(":");
			    str.append(offset_y);
			    str.append(":");
			    str.append(bg_color);
	
			}

    	}
    	catch(Exception e)
    	{
    		UtilLog.write("database error:" + e.getMessage());
    	}


    	db.shutdown();

    	rsp.setString(str.toString());
 
    	return rsp.toBytes();
    }

}

