
package request;

import java.sql.ResultSet;

import db.Database;
import response.*;
import util.UtilByte;
import util.UtilLog;
import util.UtilNet;

//////////////////////////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////////////////////////
public class RequestGetQuizQuestions extends Request
{

	//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
    public RequestGetQuizQuestions(byte[] in_data)
    {
    	super(in_data);

    	id = Request.ID_GET_QUIZ_QUESTIONS;
    }

	//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
    public byte[] process() throws Exception
    {
    	String url_quiz = null;   	

    	int idx_start;
    	
    	idx_start = 1;
    	int len_group_id = UtilByte.byteArrayToInt(data,idx_start);
    	idx_start += 4;

    	//get group_id
    	String group_id = new String(data,idx_start,len_group_id);
    	idx_start += len_group_id;

    	//get userid len
    	int len_user_id = UtilByte.byteArrayToInt(data,idx_start);
    	idx_start += 4;
    	
    	//get userid
    	String user_id = new String(data,idx_start,len_user_id);
    	idx_start += len_user_id;
    	
    	
    	int len_quiz_id = UtilByte.byteArrayToInt(data,idx_start);
    	idx_start += 4;
    	
    	//get quiz_id
    	String quiz_id = new String(data,idx_start,len_quiz_id);
    	idx_start += len_quiz_id;
    	
    	int len_course_module_id = UtilByte.byteArrayToInt(data,idx_start);
    	idx_start += 4;
    	
    	//get course_module_id
    	String course_module_id = new String(data,idx_start,len_course_module_id);
    	idx_start += len_course_module_id;
	
    	Response rsp = new Response(Request.ID_GET_QUIZ_QUESTIONS);

    	//get the quiz_url from the database based on the group id
    	boolean ret;
    	String str_out = "0";
    	ResultSet rs;
    	String str = "";
    	Database db = new Database();
    	try
    	{
    		rs = db.callRead("select url_quiz from groups where id=" + group_id);

	    	ret = rs.next();
	    	if (ret != false)
	    		url_quiz = rs.getString("url_quiz"); 
   
	    	if (url_quiz == null)
	    	{
	    		str_out = "0";
	    	}
	    	else
	    	{
	    		str = UtilNet.httpPost(url_quiz,"course_module=" + course_module_id + "&user_id=" + user_id);

	    		if (str.subSequence(0,24).equals("There is no coursemodule"))
		    	{
		    		str_out = "0";	
		    	}
		    	else //success!
		    	{
		    		str_out = "1";
		    		
			    	//append quiz info
			    	str_out += str;
		    	}
	    	}
    	}
    	catch(Exception e)
    	{
    		UtilLog.write("database error:" + e.getMessage());
    	}

    	db.shutdown();
 	
    	rsp.setString(str_out.toString());
    	
    	return rsp.toBytes();
    }

}

