
package request;

import java.sql.ResultSet;


import db.Database;
import response.*;
import util.*;

//////////////////////////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////////////////////////
public class RequestLogin extends Request
{

	//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
    public RequestLogin(byte[] in_data)
    {
    	super(in_data);

    	id = Request.ID_LOGIN;
    }

	//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
    public byte[] process() throws Exception
    {
    	String url_auth = null;   	

    	int idx_start;

		UtilLog.write("      login message start");

    	
    	idx_start = 1;
    	int len_group_id = UtilByte.byteArrayToInt(data,idx_start);
    	idx_start += 4;

    	//get group_id
    	String group_id = new String(data,idx_start,len_group_id);
    	idx_start += len_group_id;

    	int len_username = UtilByte.byteArrayToInt(data,idx_start);
    	idx_start += 4;
    	
    	//get username
    	String username = new String(data,idx_start,len_username);
    	idx_start += len_username;

    	int len_password = UtilByte.byteArrayToInt(data,idx_start);
    	idx_start += 4;
    	
    	String password = new String(data,idx_start,len_password);
    	
		UtilLog.write("        got data");

		UtilLog.write("          group id: " + group_id);
		UtilLog.write("          username: " + username);

		
    	Response rsp = new Response(Request.ID_LOGIN);
    	String str_out = "0";
    	String str = "";
    	boolean ret;
    	
    	//get the authentiation url from the database based on the group id
    	ResultSet rs;
    	Database db = new Database();
    	try
    	{
    		rs = db.callRead("select url_auth from groups where id=" + group_id);

    		UtilLog.write("        finished db call");

	    	ret = rs.next();
	    	if (ret != false)
	    		url_auth = rs.getString("url_auth"); 

   
	    	if (url_auth == null)
	    	{
	    		str_out = "0";
	    	}
	    	else
	    	{
		    	str = UtilNet.httpPost(url_auth,"username=" + username + "&password=" + password);

				UtilLog.write("        finished net call to moodle");

		    	if (str.subSequence(0,13).equals("can't log in!"))
		    	{
		    		str_out = "0";
		    		UtilLog.write("          unable to login");

		    	}
		    	else //success!
		    	{
		    		str_out = "1";
		    		
			    	//check if this is the first time that this user has connected to spark
					rs = db.callRead("select username from users where username='" + username + "' and group_id = " + group_id);

		    		UtilLog.write("          success");

					UtilLog.write("        finished 2nd db call");

			    	ret = rs.next();
			    	if (ret == false)
			    	{
			    		//insert this new user into the database
			    		db.callWrite("insert into users values('" + username + "','" + group_id + "')");			    		
			    	}
			    	else
			    	{
			    		//existing user
			    	}
			    	
			    	//append on additional login info  - ie courses/quiz info
			    	str_out += str;
		    	}
	    	}
    	
    	}
    	catch(Exception e)
    	{
    		UtilLog.write("database error:" + e.getMessage());
    	}
    	
    	db.shutdown();

    	rsp.setString(str_out.toString());
    	 
		UtilLog.write("      login message end");

    	return rsp.toBytes();
    }

}

