
package request;

import java.net.Socket;

import response.*;

import util.UtilByte;
import util.UtilLog;

//////////////////////////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////////////////////////
public class RequestSendClientInfo extends Request
{
	private String os;
	private String ver;
	
	//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
    public RequestSendClientInfo(byte[] in_data)
    {
   	
    	super(in_data);

     	id = Request.ID_SEND_CLIENT_INFO;
    }


    
	//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
    public byte[] process() throws Exception
    {
   	   	
    	int idx_start;
    	
    	idx_start = 1;
    	int len_os = UtilByte.byteArrayToInt(data,idx_start);
    	idx_start += 4;

    	//get os
    	 os = new String(data,idx_start,len_os);
    	idx_start += len_os;

    	int len_version = UtilByte.byteArrayToInt(data,idx_start);
    	idx_start += 4;
    	
    	//get flash version
    	ver = new String(data,idx_start,len_version);
    	idx_start += len_version;
    	
    	Response rsp = new Response(Request.ID_SEND_CLIENT_INFO);
    	rsp.setString("info");
    	
    	return rsp.toBytes();
    	   	

    }
    
	//////////////////////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////////////////////
    public void display(Socket socket) throws Exception
    {
		UtilLog.write("    client info for  " + socket.getInetAddress());
		UtilLog.write("        os: " + os);
		UtilLog.write("        flash version: " + ver);

    }

}

