package util;

import java.io.*;
import java.text.*;
import java.util.*;

import config.*;

///////////////////////////////////////////////////////
//
//////////////////////////////////////////////////////
public class UtilLog
{

	///////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////
	synchronized public static void write(String str)
	{	
		if (Config.is_log_active == false)
			return;
			
		System.out.println(str);
		
		Date now = new java.util.Date();

        str = "[" + DateFormat.getInstance().format(now) + "] " + str;

        try
        {
           	FileWriter fstream;
        	BufferedWriter out;
        	
        	File f = new File(Config.log_file);
        	if (f.length() > Config.max_log_file_length)
        	{
        		//clear contents of file
            	fstream = new FileWriter(Config.log_file, false);
            	out = new BufferedWriter(fstream);
    			out.write(str);
    			out.newLine();
    			out.close();
        	}
        	
        	fstream = new FileWriter(Config.log_file, true);
        	out = new BufferedWriter(fstream);
			out.write(str);
			out.newLine();
			out.close();
        }
        catch (Exception e)
        {
        	System.err.println("Error: " + e.getMessage());
        }
    }

	///////////////////////////////////////////////////////
	//
	//////////////////////////////////////////////////////
	synchronized public static void clear()
	{
		try
        {
			FileWriter fstream = new FileWriter(Config.log_file, false);
			BufferedWriter out = new BufferedWriter(fstream);
			out.write("server log");
			out.newLine();
			out.newLine();
			out.close();
        }
        catch (Exception e)
        {
        	System.err.println("Error: " + e.getMessage());
        }	
	}
}