package util;


import java.net.*;
import java.io.*;


///////////////////////////////////////////////////////
//
//////////////////////////////////////////////////////
public class UtilNet
{
	private static final int CYCLE_BUFFER_SIZE = 4096;
	
	/* 
	NOTE: if you want to use this function - setup a cycle buffer
	///////////////////////////////////////////////////////////////
	//
	///////////////////////////////////////////////////////////////
	public static synchronized String httpGet(String str_url) throws Exception
	{
		String str;

		URL url;
		HttpURLConnection conn = null;
		InputStream input_stream = null;
		BufferedInputStream buffered_input_stream = null;
		int numbytes;
		byte[] b = new byte[MAX_BUFFER_SIZE];
		
		try
		{
			url = new URL(str_url);
			conn = (HttpURLConnection)url.openConnection();

			//set connection properties
			conn.setRequestProperty("User-Agent", "Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0)");
			conn.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
			conn.setRequestProperty("Cache-Control", "no-cache");
			conn.setDoInput(true);
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			
			conn.connect();
			input_stream = conn.getInputStream();
		}
		catch(Exception e)
		{
			UtilLog.writeInfo("error trying to connect to url: " + str_url);
			return null;
		}

		try
		{
			buffered_input_stream = new BufferedInputStream(input_stream);

			numbytes = buffered_input_stream.read(b, 0, MAX_BUFFER_SIZE);

			if (numbytes < 0)
			{
				UtilLog.writeInfo("no data available from: " + str_url);
				return null;
			}
			else
			{
				str = new String(b,0,numbytes);
			}

			str = str.trim();

			return str;
		}
		catch(Exception e)
		{
			UtilLog.writeInfo("failed trying to read data from: " + str_url);
			return null;
		}
		finally
		{

			if (buffered_input_stream != null)
				buffered_input_stream.close();

			if (input_stream != null)
				input_stream.close();

			if (conn != null)
				conn.disconnect();
		}
	}
	*/
	
	///////////////////////////////////////////////////////////////
	//
	// this post encrypts it's data
	//
	///////////////////////////////////////////////////////////////
	public static synchronized String httpPost(String str_url, String str_data) throws Exception
	{
		StringBuffer str = new StringBuffer();

		URL url;
		HttpURLConnection conn = null;
		InputStream input_stream = null;
		DataOutputStream output_stream = null;
		BufferedInputStream buffered_input_stream = null;
		int numbytes;
	
		
		try
		{
			url = new URL(str_url);
			conn = (HttpURLConnection)url.openConnection();

			//set connection properties
			conn.setRequestProperty("User-Agent", "Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0)");
			conn.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
			conn.setRequestProperty("Cache-Control", "no-cache");
			conn.setDoInput(true);
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			
			conn.connect();

			//set output stream
			output_stream = new DataOutputStream(conn.getOutputStream());
			
			byte buf_enc[] = str_data.getBytes();
			UtilCipher.encrypt(buf_enc);
			
			//output_stream.writeBytes(str_data);
			output_stream.write(buf_enc,0,buf_enc.length);

			input_stream = conn.getInputStream();
		}
		catch(Exception e)
		{
			UtilLog.write("error trying to connect to url: " + str_url);
			return null;
		}

		try
		{
			//create cycling buffer
			byte[] b = new byte[CYCLE_BUFFER_SIZE];

			buffered_input_stream = new BufferedInputStream(input_stream);

			numbytes = buffered_input_stream.read(b, 0, CYCLE_BUFFER_SIZE);
			while(numbytes >= 0)
			{	
				String s = new String(b,0,numbytes);

				if (numbytes > 0)
					str.append(s);

				numbytes = buffered_input_stream.read(b, 0, CYCLE_BUFFER_SIZE);
			}
			
			return str.toString().trim();
		}
		catch(Exception e)
		{
			UtilLog.write("failed trying to read data from: " + str_url);
			return null;
		}
		finally
		{

			if (buffered_input_stream != null)
				buffered_input_stream.close();

			if (input_stream != null)
				input_stream.close();

			if (output_stream != null)
				output_stream.close();

			if (conn != null)
				conn.disconnect();
		}
	}
}