<?php
	require_once('../config.php');
	require_once('../mod/quiz/locallib.php');
    require_once("sparkmarblelib.php");

	global $USER;
	
	$user_id = required_param('user_id');
    $course_module = required_param('course_module');
    $debug = optional_param('debug', '0');
    
	complete_user_login(get_complete_user_data('id', $user_id));
	
	if ($course_module)
	{
		if (! $cm = get_coursemodule_from_id('quiz', $course_module))
		{
			echo "There is no coursemodule with id $course_module";
		}
		if (! $course = get_record("course", "id", $cm->course))
		{
			echo "Course is misconfigured";
		}
		if (! $quiz = get_record("quiz", "id", $cm->instance))
		{
			echo "The quiz with id $cm->instance corresponding to this coursemodule $course_module is missing";
		}
	}
	else
	{
		echo "No ID specified in URL";
	}

    if(!$attemptnumber = (int)get_field_sql('SELECT MAX(attempt)+1 FROM ' .
            "{$CFG->prefix}quiz_attempts WHERE quiz = '{$quiz->id}' AND " .
            "userid = '{$USER->id}' AND timefinish > 0 AND preview != 1")) {
        $attemptnumber = 1;
    }

	$questionlist = quiz_questions_in_quiz(quiz_questions_in_quiz($quiz->questions));

	$quiz->questionlist = $questionlist;
	
    $sql = "SELECT q.*, i.grade AS maxgrade, i.id AS instance".
           "  FROM {$CFG->prefix}question q,".
           "       {$CFG->prefix}quiz_question_instances i".
           " WHERE i.quiz = '$quiz->id' AND q.id = i.question".
           "   AND q.id IN ($questionlist)";

    // Load the questions
    if (!$questions = get_records_sql($sql)) {
        echo "noquestionsfound for quiz: view.php?q=".$quiz->id;
    }

    // Load the question type specific information
    if (!get_question_options($questions)) {
        echo 'Could not load question options';
    }
	
	$quiz->questions = $questions;
	
	echo format_quiz_data($quiz);
?>
<?php
	if ($debug)
	{
		echo "<form action='set_results.php' method='post'>";
		echo "<input type='hidden' name='quiz_id' value='$quiz->id' />";
		echo "<input type='hidden' name='user_id' value='$USER->id' />";
		echo "<input type='hidden' name='questionids' value='$questionlist' />";
		echo "<input type='hidden' name='finishattempt' value='Submit all and finish' />";
		foreach ($questions as $i => $question)
		{
			foreach ($question->options->answers as $answer)
			{
				if ($answer->fraction == 1)
				{
					echo "<input type='hidden' name='$question->name_prefix' value='$answer->id' />";		
				}
			}	
		}
		echo "<input type='submit' />";
		echo "</form>";
	}
?>