<?php
	require_once('../config.php');
	require_once('../mod/quiz/locallib.php');
    require_once("sparkmarblelib.php");
	
	global $USER;
	
    $timestamp = time();

	$user_id = required_param('user_id');
    $quiz_id = required_param('quiz_id');
    $questionids = optional_param('questionids', '');
    $finishattempt = optional_param('finishattempt', 0, PARAM_BOOL);
    
	complete_user_login(get_complete_user_data('id', $user_id));
    
	if (! $quiz = get_record("quiz", "id", $quiz_id)) {
		echo "There is no quiz with id $quiz_id";
	}

	/// Get number for the next or unfinished attempt
	if(!$attemptnumber = (int)get_field_sql('SELECT MAX(attempt)+1 FROM ' .
		"{$CFG->prefix}quiz_attempts WHERE quiz = '{$quiz->id}' AND " .
		"userid = '{$USER->id}' AND timefinish > 0 AND preview != 1")) {
		$attemptnumber = 1;
	}

	// Delete any previous preview attempts belonging to this user.
	if ($oldattempts = get_records_select('quiz_attempts', "quiz = '$quiz->id' AND userid = '$USER->id' AND preview = 1")) {
		foreach ($oldattempts as $oldattempt) {
			quiz_delete_attempt($oldattempt, $quiz);
		}
	}
	
	$newattempt = true;
	// Start a new attempt and initialize the question sessions
	$attempt = quiz_create_attempt($quiz, $attemptnumber);

	// Save the attempt
	if (!$attempt->id = insert_record('quiz_attempts', $attempt)) {
		echo 'Could not create new attempt';
	}

	$sql = "SELECT q.*, i.grade AS maxgrade, i.id AS instance".
		"  FROM {$CFG->prefix}question q,".
		"       {$CFG->prefix}quiz_question_instances i".
		" WHERE i.quiz = '$quiz->id' AND q.id = i.question".
		"   AND q.id IN ($questionids)";
	
	// Load the questions
	if (!$questions = get_records_sql($sql)) {
		echo "no questions found!";
	}
	
    if (!get_question_options($questions)) {
        error('Could not load question options');
    }

	if (!$states = get_question_states($questions, $quiz, $attempt, $lastattemptid)) {
		error('Could not restore question sessions');
	}

	// Save all the newly created states
	if ($newattempt) {
		foreach ($questions as $i => $question) {
			save_question_session($questions[$i], $states[$i]);
		}
	}
	
	if ($responses = data_submitted() and empty($responses->quizpassword)) {

		// set the default event. This can be overruled by individual buttons.
		$event = (array_key_exists('markall', $responses)) ? QUESTION_EVENTSUBMIT :
		($finishattempt ? QUESTION_EVENTCLOSE : QUESTION_EVENTSAVE);
		
		// Unset any variables we know are not responses
		unset($responses->id);
		unset($responses->q);
		unset($responses->questionids);
		unset($responses->saveattempt); // responses get saved anway
		unset($responses->finishattempt); // same as $finishattempt
		unset($responses->markall);

		// extract responses
		// $actions is an array indexed by the questions ids
		$actions = question_extract_responses($questions, $responses, $event);
		
		// Process each question in turn
		$questionidarray = explode(',', $questionids);
		$success = true;
		foreach($questionidarray as $i) {
			if (!isset($actions[$i])) {
				$actions[$i]->responses = array('' => '');
				$actions[$i]->event = QUESTION_EVENTOPEN;
			}
			$actions[$i]->timestamp = $timestamp;
			if (question_process_responses($questions[$i], $states[$i], $actions[$i], $quiz, $attempt)) {
				save_question_session($questions[$i], $states[$i]);
			} else {
				$success = false;
			}
		}
	
		$attempt->timemodified = $timestamp;
		$attempt->timefinish = $timestamp;

		// load all the questions
		$closequestionlist = quiz_questions_in_quiz($attempt->layout);
		$sql = "SELECT q.*, i.grade AS maxgrade, i.id AS instance".
			"  FROM {$CFG->prefix}question q,".
			"       {$CFG->prefix}quiz_question_instances i".
			" WHERE i.quiz = '$quiz->id' AND q.id = i.question".
			"   AND q.id IN ($closequestionlist)";

		if (!$closequestions = get_records_sql($sql)) {
			echo 'Questions missing';
		}

		// Load the question type specific information
		if (!get_question_options($closequestions)) {
			echo 'Could not load question options';
		}

		// Restore the question sessions
		if (!$closestates = get_question_states($closequestions, $quiz, $attempt)) {
			error('Could not restore question sessions');
		}

		$success = true;
		foreach($closequestions as $key => $question) {
			$action->event = QUESTION_EVENTCLOSE;
			$action->responses = $closestates[$key]->responses;
			$action->timestamp = $closestates[$key]->timestamp;
			
			if (question_process_responses($question, $closestates[$key], $action, $quiz, $attempt)) {
				save_question_session($question, $closestates[$key]);
			} else {
				$success = false;
			}
		}
	}

	/// Update the quiz attempt and the overall grade for the quiz
	if ($responses || $finishattempt) {
		if (!update_record('quiz_attempts', $attempt)) {
			echo 'Failed to save the current quiz attempt!';
		}
		if (($attempt->attempt > 1 || $attempt->timefinish > 0) and !$attempt->preview) {
			quiz_save_best_grade($quiz);
		}
	}
	
	/// Send emails to those who have the capability set
	if ($finishattempt && !$attempt->preview) {
		quiz_send_notification_emails($course, $quiz, $attempt, $context, $cm);
	}
	
	$quiz_result = quiz_get_user_grades($quiz, $USER->id);
	$attempt->grade = $quiz_result[$USER->id]->rawgrade;

	echo format_attempt_data($attempt);
?>