<?php
    require_once("xmlconverter.php");
    
	function format_user_data($user)
	{
		$clean_user['id'] = $user->id;
		$clean_user['username'] = $user->username;

		$clean_course_array = array();
		
	    foreach ($user->courses as $i => $course)
	    {
	    	$this_course['id'] = $course->id;
	    	$this_course['fullname'] = $course->fullname;
	    	
	    	$clean_quiz_array = array();
	    	
			foreach ($course->quizzes as $i => $quiz)
			{
				$this_quiz['id'] = $quiz->id;
				$this_quiz['course_module'] = $quiz->coursemodule;
				$this_quiz['name'] = $quiz->name;
				$this_quiz['intro'] = $quiz->intro;
				
				$clean_quiz_array[] = $this_quiz;
			}
			$this_course['quizzes'] = $clean_quiz_array;
			$clean_course_array[] = $this_course;
	    }
		
		$clean_user['courses'] = $clean_course_array;
		try 
		{
		    $xml = new array2xml('sparkmarble');
		    $xml->createNode( $clean_user );
		} 
		catch (Exception $e) 
		{
			return null;
		}
		return $xml;
	}
	
	function format_userlist_data($users)
	{
		$clean_users_array = array();
		
	    foreach ($users as $user)
	    {
			$clean_user['id'] = $user->id;
			$clean_user['username'] = $user->username;
			$clean_users_array[] = $clean_user;
	    }
	
		try 
		{
		    $xml = new array2xml('sparkmarble');
		    $xml->createNode( $clean_users_array );
		} 
		catch (Exception $e) 
		{
			return null;
		}
		return $xml;
	}
	function format_quiz_data($quiz)
	{
		$clean_quiz['id'] = $quiz->id;
		$clean_quiz['name'] = $quiz->name;
		$clean_quiz['intro'] = $quiz->intro;
		$clean_quiz['questionlist'] = $quiz->questionlist;

		$clean_question_array = array();
		
	    foreach ($quiz->questions as $i => $question)
	    {
	    	$this_question['id'] = $question->id;
	    	$this_question['name'] = $question->name;
	    	$this_question['questiontext'] = $question->questiontext;
	    	$this_question['name_prefix'] = $question->name_prefix;
	    	
	    	$clean_answer_array = array();
	    	
			foreach ($question->options->answers as $i => $answers)
			{
				$this_answer['id'] = $answers->id;
				$this_answer['answer'] = $answers->answer;
				$this_answer['fraction'] = $answers->fraction;
				
				$clean_answer_array[] = $this_answer;
			}
			$this_question['answers'] = $clean_answer_array;
			$clean_question_array[] = $this_question;
	    }
		
		$clean_quiz['questions'] = $clean_question_array;
		try 
		{
		    $xml = new array2xml('sparkmarble');
		    $xml->createNode( $clean_quiz );
		} 
		catch (Exception $e) 
		{
			return null;
		}
		return $xml;	
	}
		
	function format_attempt_data($attempt)
	{
		$clean_attempt['user_id'] = $attempt->userid;
		$clean_attempt['id'] = $attempt->id;
		$clean_attempt['attempt'] = $attempt->attempt;
		$clean_attempt['grade'] = $attempt->grade;
		$clean_attempt['sumgrades'] = $attempt->sumgrades;

		try 
		{
		    $xml = new array2xml('sparkmarble');
		    $xml->createNode( $clean_attempt );
		} 
		catch (Exception $e) 
		{
			return null;
		}
		return $xml;	
	}
?>
